<app-loading *ngIf="isLoading"></app-loading>
<div class="main-init-project content-header">
  <div class="main-init-project__right">
    <mb-button mbButtonSize='MEDIUM' mbButtonAvailableStyle='PRIMARY' (click)="validateRequest('SAVE')"
      mbButtonText="{{'Lưu' | translate}}" [mbIsDisable]="isLoading || (id && checkRequestApprove)"
      *ngIf="objFunction?.create">
    </mb-button>
    <mb-button mbButtonSize='MEDIUM' mbButtonAvailableStyle='PRIMARY' (click)="validateRequest('SAVE_AND_SEND_APPROVE')"
      mbButtonText="{{'Chuyển duyệt' | translate}}" [mbIsDisable]="isLoading" *ngIf="objFunction?.create">
    </mb-button>
  </div>
</div>

<nz-card class="main-init-project-card">
  <form [formGroup]="initProjectForm" nz-form>
    <div nz-row>
      <div nz-col nzSpan="12" class="main-init-project-card-border-right">

        <div nz-row>
          <div nz-col nzSpan="12" class="main-init-project-card__left">
            <nz-form-label [nzNoColon]="true" class="text-bold">Tên dự án <p class="required">*</p>
            </nz-form-label>
            <nz-form-item>
              <nz-form-control>
                <input placeholder="Tên dự án" maxlength="100" nz-input class="main-init-project-card__left__input" [autoFocus]='true'
                  formControlName="prjName" (ngModelChange)="onCheckRequestApprove()" />
                <span
                  *ngIf="initProjectForm.controls['prjName'].invalid && initProjectForm.controls['prjName'].dirty && initProjectForm.controls['prjName'].errors.required"
                  class="color-error-file">
                  <em nz-icon nzType="close-circle" nzTheme="outline"></em> Trường bắt buộc nhập
                </span>
              </nz-form-control>
            </nz-form-item>

          </div>
          <div nz-col nzSpan="12" class="main-init-project-card__center">
            <nz-form-label [nzNoColon]="true" class="text-bold">Số quyết định <p class="required">*</p>
            </nz-form-label>
            <nz-form-item>
              <nz-form-control>
                <input placeholder="Số quyết định" maxlength="100" nz-input
                  class="main-init-project-card__center__input" formControlName="sapNo"
                  (ngModelChange)="onCheckRequestApprove()" />
                <span
                  *ngIf="initProjectForm.controls['sapNo'].invalid && initProjectForm.controls['sapNo'].dirty && initProjectForm.controls['sapNo'].errors.required"
                  class="color-error-file">
                  <em nz-icon nzType="close-circle" nzTheme="outline"></em> Trường bắt buộc nhập
                </span>
              </nz-form-control>
            </nz-form-item>
          </div>

        </div>

        <div nz-row>
          <div nz-col nzSpan="12" class="main-init-project-card__left form-row__right">
            <nz-form-label [nzNoColon]="true" class="text-bold">File đính kèm <p class="required">*</p>
            </nz-form-label>
            <nz-form-item>
              <nz-form-control nzValidateStatus="" [nzErrorTip]="">
                <div style="display: flex;">
                  <img alt="" (click)="fileInput.click()" src="assets/images/icon/Group 14048.svg">
                  <input formControlName="file" accept=".pdf" hidden type="file" #fileInput
                    (change)="handleFileInput($event)">
                  <input formControlName="fileName" hidden>
                  <mat-chip (removed)="removeChip()" *ngIf="fileName" class="form-row__right--mat-chip-file">
                    <a class="form-row__right--fileName" (click)="downloadFile()">
                      {{fileName}}
                    </a>
                    <button matChipRemove class="form-row__right--button">
                      <em nz-icon nzType="close-circle" nzTheme="outline"></em>
                    </button>
                  </mat-chip>
                </div>
              </nz-form-control>
            </nz-form-item>
            <span
              *ngIf="initProjectForm.controls['fileName'].invalid && initProjectForm.controls['fileName'].dirty && initProjectForm.controls['fileName'].errors.required"
              class="color-error-file">
              <em nz-icon nzType="close-circle" nzTheme="outline"></em> Trường bắt buộc nhập
            </span>
            <span *ngIf="errorMessageMaxFileSize" class="color-error-file">{{errorMessageMaxFileSize}}</span>
          </div>

          <div nz-col nzSpan="12" class="main-init-project-card__center">
            <nz-form-label [nzNoColon]="true" class="text-bold">Đơn vị quản lý dự án
              <p class="required">*</p>
            </nz-form-label>
            <mb-select-check-able formControlName="unit" [(ngModel)]="multipleValue"
              [mbType]="errorUnit ? 'error' : 'default'" [mbDataSelects]="listProject" mbKeyLabel="orgName"
              mbMode="multiple" mbKeyValue="orgId" mbType="default" mbPlaceholder="Đơn vị quản lý dự án"
              (ngModelChange)="onChangeUnit($event)">
            </mb-select-check-able>
            <span *ngIf="errorUnit" class="color-error-file"><em nz-icon nzType="close-circle" nzTheme="outline"></em>
              Trường bắt buộc nhập</span>
          </div>

        </div>

        <div nz-row style="margin-top: 10px;">
          <div nz-col nzSpan="12" class="main-init-project-card__left">
            <nz-form-label [nzNoColon]="true" class="text-bold">Ngày hiệu lực
              <span class="required">*</span>
            </nz-form-label>
            <nz-form-item>
              <nz-form-control>
                <nz-date-picker [ngStyle]="errorDate && {'border': '1px solid #ff4d4f'}" formControlName="fromDate"
                  [nzFormat]="'dd/MM/yyyy'" (ngModelChange)="onCheckRequestApprove()" nzPlaceHolder="Ngày hiệu lực">
                </nz-date-picker>
                <span
                  *ngIf="initProjectForm.controls['fromDate'].invalid && initProjectForm.controls['fromDate'].dirty && initProjectForm.controls['fromDate'].errors.required"
                  class="color-error-file">
                  <em nz-icon nzType="close-circle" nzTheme="outline"></em> Trường bắt buộc nhập
                </span>
              </nz-form-control>
            </nz-form-item>
            <span *ngIf="errorDate" class="color-error-file">
              <em nz-icon nzType="close-circle" nzTheme="outline"></em> {{errorDate}}
            </span>
          </div>
          <div nz-col nzSpan="12" class="main-init-project-card__left">
            <nz-form-label [nzNoColon]="true" class="text-bold">Ngày hết hiệu lực
            </nz-form-label>
            <nz-form-item>
              <nz-form-control nzValidateStatus="">
                <nz-date-picker [ngStyle]="errorDate && {'border': '1px solid #ff4d4f'}" formControlName="toDate"
                  [nzFormat]="'dd/MM/yyyy'" nzPlaceHolder="Ngày hết hiệu lực"></nz-date-picker>
              </nz-form-control>
            </nz-form-item>
          </div>
        </div>

        <div nz-row>
          <div nz-col nzSpan="12" class="main-init-project-card__left">
            <nz-form-label [nzNoColon]="true" class="text-bold">Mã dự án
            </nz-form-label>
            <nz-form-item>
              <nz-form-control>
                <input placeholder="Mã dự án" maxlength="30" nz-input class="main-init-project-card__card__right__input"
                  formControlName="prjCode" />
              </nz-form-control>
            </nz-form-item>
            <span nz-typography>(Dành cho PM dự án nhập để liên kế dữ liệu)</span>
          </div>
        </div>
        <div nz-row>
          <div nz-col nzSpan="24" class="custom-padding-row">
            <mb-input-text formControlName="scopeContents" [mbIsTextAre]="true" [mbMaxLength]="300"
              [mbType]="initProjectForm.dirty && (initProjectForm.controls['scopeContents'].errors || initProjectForm.errors?.noAllowSpace) ? 'error' : 'default'"
              [mbShowError]="initProjectForm.dirty && (initProjectForm.controls['scopeContents'].errors || initProjectForm.errors?.noAllowSpace) !== null"
              [mbErrors]="initProjectForm.controls['scopeContents'].errors" [mbErrorDefs]="[
              { errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '100' }},
              { errorName: 'required', errorDescription: 'Trường bắt buộc nhập' },
              { errorName: 'noAllowSpace', errorDescription: 'Trường bắt buộc nhập' | translate }]"
              mbPlaceholderText="{{'Phạm vi công việc, 300 ký tự' | translate}}"
              mbLabelText="{{'Phạm vi công việc' | translate}}" (ngModelChange)="onCheckRequestApprove()">
            </mb-input-text>
          </div>
        </div>
      </div>
      <div nz-col nzSpan="12" class="custom-padding-for-job">
        <div nz-row>
          <div nz-col nzSpan="24" formArrayName="projectPositions">
            <div nz-row *ngFor="let data of projectPositions.controls; let i = index" [formGroupName]="i"
              style="margin-bottom: 15px;">
              <div nz-col nzSpan="12">
                <nz-form-label [nzNoColon]="true" class="text-bold" *ngIf="i === 0">Job dự án <p class="required">*</p>
                </nz-form-label>
                <mb-select formControlName="jobId"
                  [mbType]="(data['controls']?.jobId && data['controls']?.jobId?.errors && data['controls']?.jobId?.errors?.required) ? 'error' : 'default'"
                  [mbDataSelects]="listJob" mbKeyLabel="jobName" mbKeyValue="jobId" mbType="default"
                  mbPlaceholder="Job dự án" (ngModelChange)="onCheckRequestApprove()">
                </mb-select>
                <span class="color-error-file"
                  *ngIf="data['controls']?.jobId && data['controls']?.jobId?.errors && data.get['controls'].jobId.errors.required">
                  <em nz-icon nzType="close-circle" nzTheme="outline"></em> Trường bắt buộc nhập
                </span>
              </div>
              <div nz-col nzSpan="12">
                <div class="flex-for-quality">
                  <div class="margin-for-quality">
                    <nz-form-label [nzNoColon]="true" class="text-bold" *ngIf="i === 0">
                      Số lượng
                    </nz-form-label>
                    <div class="btn-add">
                      <input style="margin-top: 4px;" nz-input formControlName="headCount"
                        (ngModelChange)="onCheckRequestApprove()" placeholder="Số lượng"
                        (keypress)="($event.charCode >= 48 && $event.charCode < 58)"
                        [ngStyle]="!!(data['controls']?.headCount && data['controls'].headCount.errors && data.get['controls'].headCount.errors.required) && {'border': '1px solid red'}" />
                      <a style="margin-left: 5px;" (click)="addJob()"> <img alt=""
                          src="assets/images/icon/add_circle_outline.svg" width="20" height="20"></a>
                      <a style="margin-left: 5px;" (click)="removeJob(i)">
                        <img alt="" src="assets/images/icon/delete_outline.svg" width="20" height="20">
                      </a>
                    </div>
                    <span class="color-error-file"
                      *ngIf="data['controls'].headCount && data['controls'].headCount.errors && data['controls'].headCount.errors.required">
                      <em nz-icon nzType="close-circle" nzTheme="outline"></em> Trường bắt buộc nhập
                    </span>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div nz-col nzSpan="24" formArrayName="projectAttributes">
            <div nz-row *ngFor="let data of projectAttributes.controls; let i = index" [formGroupName]="i">
              <div nz-col nzXs="2" style="margin-top: 25px;">
                <nz-form-label [nzNoColon]="true" *ngIf="i === 0"></nz-form-label>
                <div>
                  <label nz-checkbox formControlName="attrCheckBox" (ngModelChange)="onCheckRequestApprove()">
                  </label>
                  <input nz-input formControlName="attrCode" hidden />
                </div>
              </div>
              <div nz-col nzXs="11" style="margin-top: 10px;">
                <nz-form-label [nzNoColon]="true" class="text-bold" *ngIf="i === 0">Tiêu chí</nz-form-label>
                <input style="margin-top: 4px;" nz-input formControlName="criteria"
                  (ngModelChange)="onCheckRequestApprove()" readonly />
              </div>
              <div nz-col nzXs="11" style="margin-top: 10px;" class="select-attribute">
                <nz-form-label [nzNoColon]="true" class="text-bold" *ngIf="i === 0">Thuộc tính
                </nz-form-label>
                <ng-container *ngIf="listCriteria && listCriteria[i]">
                  <mb-select formControlName="attrValue"
                    [mbType]="(data['controls'].attrValue && data['controls'].attrValue.errors && data['controls'].attrValue.errors.required) ? 'error' : 'default'"
                    [mbDataSelects]="listCriteria[i].attributes" mbKeyLabel="lvaMean" mbKeyValue="lvaValue"
                    mbType="default" mbPlaceholder="Thuộc tính" (ngModelChange)="onChangeAttributes($event, data)">
                  </mb-select>
                </ng-container>
                <span class="color-error-file"
                  *ngIf="data['controls'].attrValue && data['controls'].attrValue.errors && data['controls'].attrValue.errors.required">
                  <em nz-icon nzType="close-circle" nzTheme="outline"></em> Trường bắt buộc nhập
                </span>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </form>
</nz-card>
<nz-modal [(nzVisible)]="isVisible" [nzTitle]="modalTitle" [nzContent]="modalContent" [nzFooter]="modalFooter"
  [nzStyle]="{ width: '80vw' }" (nzOnCancel)="handleCancel()">
  <ng-template #modalTitle>View PDF File</ng-template>

  <ng-template #modalContent>
    <div>
      <pdf-viewer [src]="pdfSrc" [show-all]="true" [fit-to-page]="true" [render-text]="true" [original-size]="true"
        class="pdf-view"></pdf-viewer>
    </div>
  </ng-template>

  <ng-template #modalFooter>
    <p></p>
  </ng-template>
</nz-modal>
